<?
  #
  # Program id     : FPDFGenerator.inc.php
  #
  # subject        : PDF documents Generator
  #

/*
** save as "FPDFGenerator.inc.php"
*/
  #
  require_once('fpdf/fpdf_ext.php');
  #
  class FPDF_Class extends FPDF_Ext
  {
    var $Debug         = FALSE;
    var $templateFileName;
    var $cfonts = array(
                        'family' => 'Big5-hw',
                        'style'  => '',
                        'size'   => '12'
                       );
    var $efonts = array(
                        'family' => 'Helvetica',
                        'style'  => '',
                        'size'   => '12'
                       );
/*
**     void FPDF_Class()
**     class constructor
*/
    function FPDF_Class($templateFileName, $Debug=FALSE)
    {
      $this->Debug = $Debug;
      if  (is_file($templateFileName))
      {
        $this->templateFileName = $templateFileName;
      }
    }
    //
    //
    //
    function Header()
    {
      if  (empty($this->templateFileName))
      {
        return;
      }
      $data = implode('', file($this->templateFileName));
      $p = xml_parser_create('ISO-8859-1');
      xml_parser_set_option($p,XML_OPTION_CASE_FOLDING,0);
      xml_parser_set_option($p,XML_OPTION_SKIP_WHITE, 0);
      xml_parse_into_struct($p, $data, &$vals, &$index);
      xml_parser_free($p);
      if  ($this->Debug)
      {
        echo "<PRE>";
        print_r($vals);
        echo "</PRE>";
      }
      foreach($vals as $key=>$val)
      {
        if  ($val[type] != 'complete')
        {
          continue;
        }
        if  ($this->Debug)
        {
          echo 'tag ->' . $val[tag] . "<br>\n";
          if  ($val[attributes])
          {
            foreach($val[attributes] as $key2=>$val2)
            {
              echo $key2 . '->' . $val2 . "<br>\n";
            }
          }
        }
        switch($val[tag])
        {
          case 'line':
               $sx  = $val[attributes][sx];
               $sy  = 842 - $val[attributes][sy];
               $ex  = $val[attributes][ex];
               $ey  = 842 - $val[attributes][ey];
               $lw  = (float)$val[attributes][linewidth];
               if  ($lw==(float)(0.0))
               {
                 $lw = (float)(0.001);
               }
               if  ($val[attributes][repeat])
               {
                 $repeat = $val[attributes][repeat];
               }
               else
               {
                 $repeat = 1;
               }
               $incx  = (int)($val[attributes][incx]);
               $incy  = (-1) * (int)($val[attributes][incy]);
               if  ($this->Debug)
               {
                 echo "$sx $sy $ex $ey $incx $incy $repeat<BR>\n";
               }
               if  ($lw)
               {
                 $this->SetLineWidth($lw);
               }
               for($i=0; $i < $repeat; $i++)
               {
                 $this->Line($sx + ($i * $incx), $sy + ($i * $incy), $ex + ($i * $incx), $ey + ($i * $incy));
               }
               break;
          case 'rect':
               $sx    = $val[attributes][sx];
               $sy    = $val[attributes][sy];
               $w     = $val[attributes][width];
               $h     = $val[attributes][height];
               $style = $val[attributes][style];
               $lw  = (float)$val[attributes][linewidth];
               if  ($lw==(float)(0.0))
               {
                 $lw = (float)(0.001);
               }
               if  ($this->Debug)
               {
                 echo "$sx $sy $w $h $lw<BR>\n";
               }
               if  ($lw)
               {
                 $this->SetLineWidth($lw);
               }
               $this->Rect($sx, $sy, $w, $h, $style);
               break;
          case 'text':
               $this->ShowText(($val[attributes][value]),
                               $val[attributes][x],
                               $val[attributes][y],
                               $val[attributes][size],
                               $val[attributes][type]
                              );

               break;
        }
      }
    }    
    //
    // Write Text
    //
    function ShowText($text, $posx=0, $posy=0, $fontsize=10, $fontfamily='cfont')
    {
      if  ($fontfamily == 'cfont')
      {
        $fontfamily = $this->cfonts[family]; 
        $fontstyle  = $this->cfonts[style]; 
      }
      else
      {
        $fontfamily = $this->efonts[family]; 
        $fontstyle  = $this->efonts[style]; 
      }
      $this->SetFont($fontfamily, $fontstyle, $fontsize);
      #echo "x = " . $this->GetX() . "<BR>";
      #echo "y = " . $this->Gety() . "<BR>";
      $this->SetXY($posx, 842 - $posy);
      $this->Cell(0, 10, $text);
    }
  }
  //
  //
  //
  class FPDFGenerator
  {
    var $pageWidth      = a4_width;
    var $pageHeight     = a4_height;
    var $pageOrient     = "Portrait";
    var $pageFormat     = "A4";
    var $pageUnit       = "pt";
    var $CreateNewPage  = FALSE;
    var $Debug          = FALSE;
    var $pdfDir         = '';
    var $pdf;
    var $pdfFileName;
    var $pdfFileURL;
    var $FileExpireTime = 60;
    var $cfonts = array(
                        'family' => 'Big5',
                        'style'  => '',
                        'size'   => '12'
                       );
    var $efonts = array(
                        'family' => 'Helvetica',
                        'style'  => '',
                        'size'   => '12'
                       );
    var $ErrMsg;
/*
**     void FPDFGenerator()
**     class constructor
*/
    function FPDFGenerator($templateFileName, $Debug=FALSE, $pdfDir='/pdf/pdf_files')
    {
      global $_SERVER;
      $this->Debug = $Debug;
      /*****
      if  (!empty($pdfDir))
      {
      	$this->pdfDir = $_SERVER['DOCUMENT_ROOT'] . $pdfDir;
      }
      if  (!file_exists($this->pdfDir))
      {
        mkdir($this->pdfDir, 0777);
      }
      $tempFileName = tempnam('' , 'PDF_');
      unlink($tempFileName);
      $this->pdfFileName = $this->pdfDir . '/' . basename($tempFileName) . '.pdf';
      $this->pdfFileURL  = $pdfDir . '/' . basename($tempFileName) . '.pdf';
      if  ($this->Debug)
      {
        echo 'test1 ' . $this->pdfFileName . "<BR>\n";
        echo 'test2 ' . $this->pdfFileURL  . "<BR>\n";
      }
      *****/
      if  (is_file($templateFileName))
      {
        $this->GlobalSetting($templateFileName);
      }
      $this->pdf =& new FPDF_Class($templateFileName, $this->Debug);
      $this->pdf->cfonts = $this->cfonts;
      $this->pdf->efonts = $this->efonts;
      $this->pdf->FPDF($this->pageOrient, $this->pageUnit, $this->pageFormat);
      $this->pdf->SetAuthor("Uwe Steinmann");
      $this->pdf->SetTitle("Test for PHP wrapper of FPDF 1.52");
      $this->pdf->SetCreator("See Author");
      $this->pdf->SetSubject("Testing");
      $this->pdf->AddBig5Font();
      $this->pdf->AddBig5hwFont();
    }
/*
**     void GlobalSetting()
**     Prepare PDF GlobalSetting
*/

    function GlobalSetting($templateFileName)
    {
      $data = implode('', file($templateFileName));
      $p = xml_parser_create('ISO-8859-1');
      xml_parser_set_option($p,XML_OPTION_CASE_FOLDING,0);
      xml_parser_set_option($p,XML_OPTION_SKIP_WHITE, 0);
      xml_parse_into_struct($p, $data, &$vals, &$index);
      xml_parser_free($p);
      if  ($this->Debug)
      {
        echo "<PRE>";
        print_r($vals);
        echo "</PRE>";
      }
      foreach($vals as $key=>$val)
      {
        if  ($val[type] != 'complete')
        {
          continue;
        }
        if  ($this->Debug)
        {
          echo 'tag ->' . $val[tag] . "<br>\n";
          if  ($val[attributes])
          {
            foreach($val[attributes] as $key2=>$val2)
            {
              echo $key2 . '->' . $val2 . "<br>\n";
            }
          }
        }
        switch($val[tag])
        {
          case 'page':
               $tmp = trim($val[attributes][w]);
               $this->pageWidth  = empty($tmp) ? $this->pageWidth : $tmp;
               $tmp = trim($val[attributes][h]);
               $this->pageHeight  = empty($tmp) ? $this->pageHeight : $tmp;
               $tmp = trim($val[attributes][orientation]);
               $this->pageOrient  = empty($tmp) ? $this->pageOrient : $tmp;
               $tmp = trim($val[attributes][format]);
               $this->pageFormat  = empty($tmp) ? $this->pageFormat : $tmp;
               $tmp = trim($val[attributes][unit]);
               $this->pageUnit    = empty($tmp) ? $this->pageUnit   : $tmp;
               break;
          case 'cfont':
               $this->cfonts[family]  = $val[attributes][family];
               $this->cfonts[style]   = $val[attributes][style];
               $this->cfonts[size]    = $val[attributes][size];
               break;
          case 'efont':
               $this->efonts[family]  = $val[attributes][family];
               $this->efonts[style]   = $val[attributes][style];
               $this->efonts[size]    = $val[attributes][size];
               break;
        }
      }
    }
/*
**     void NewPage()
**     create NewPage
*/
  function NewPage()
  {
    $this->pdf->AddPage();
    $this->pdf->Bookmark("Page " . $this->pdf->PageNo());
    $this->CreateNewPage = TRUE;
  }
/*
**     void OutputDoc()
**
*/
  function OutputDoc()
  {
    if ($this->CreateNewPage)
    {
      $this->pdf->Output("FPDF.pdf", "D");
    }
    // also have a look through the directory, and remove the files
    // that are older than
    if  ($d = @opendir($this->pdfDir))
    {
      while(($file= readdir($d)) != FALSE)
      {
        if  (substr($file, 0, 4) == 'PDF_')
        {
          // then check to see if this one is too old
          $ftime = filemtime($this->pdfDir . '/' . $file);
          if  (time() - $ftime > $this->FileExpireTime)
          {
            unlink($this->pdfDir . '/' . $file);
          }
        }
      }
    }
  }
/*
**     void OutputDoc_1()
**
*/
  function OutputDoc_1($Redirect=False)
  {
?>

    <HTML>
    <HEAD>
      <TITLE>PDF Generator OUTPUT</TITLE>
      <SCRIPT LANGUAGE="JavaScript">
        <!--
        function go_now()
        {
          window.open("<?=$this->pdfFileURL?>", "PDF");
          // window.location.href="<?=$this->pdfFileURL?>"
        }
        // -->
      </SCRIPT>
    </HEAD>
<?
  if  ($Redirect)
  {
    echo("<BODY OnLoad=\"go_now()\">\n");
  }
  else
  {
    echo("<BODY>\n");
  }
?>
      <A href="<?=$this->pdfFileURL?>">o</A> pSX{e
    </BODY>
    </HTML>
<?
    // also have a look through the directory, and remove the files
    // that are older than
    if  ($d = @opendir($this->pdfDir))
    {
      while(($file= readdir($d)) != FALSE)
      {
        if  (substr($file, 0, 4) == 'PDF_')
        {
          // then check to see if this one is too old
          $ftime = filemtime($this->pdfDir . '/' . $file);
          if  (time() - $ftime > $this->FileExpireTime)
          {
            unlink($this->pdfDir . '/' . $file);
          }
        }
      }
    }
  }
  //
  // Write Text
  //
    //
    // Write Text
    //
    function ShowText($text, $posx=0, $posy=0, $fontsize=10, $fontfamily='cfont')
    {
      $this->pdf->ShowText($text, 
                           $posx, 
                           $posy, 
                           $fontsize, 
                           $fontfamily
                          );
      $this->SetXY($posx, $posy);
      $this->Cell(0, 0, $text);
    }
    //
    // Write Blocked Text()
    //
    function ShowTextBlocked($text, $posx=0, $posy=0, $fontsize=10, $linelength=10, $fontfamily='cfont')
    {
      $lencnt = 0;
      if ($this->pdf)
      {
        if    ($fontfamily == 'cfont')
        {
          $font =& $this->cfont;
        }
        else
        {
          $font =& $this->efont;
        }
        PDF_setfont($this->pdf,
                    $font,
                    $fontsize
                   );
        if  (!is_array($text))
        {
          $text = $this->TextWrapLines($text, $linelength);
        }
      	$lencnt = count($text);
      	for($i = 0 ; $i < $lencnt; $i++)
      	{
          if  ($i==0)
          {
            PDF_show_xy($this->pdf, $text[$i], $posx, $posy);
          }
          else
          {
            PDF_continue_text($this->pdf, $text[$i]);
          }
        }
      }
      return($lencnt);
    }
  //
  // Text Wrap to array (lines)
  //
    function &TextWrapLines($text, $linelength=10)
    {
      $ret   = array();
      $tmp   = '';

      $len   = strlen($text);
      for($i = 0 ; $i < $len;)
      {
        $char_ord = ord(substr($text, $i, 1));
        $byte  = 1;
        if  ($char_ord >= 0x80)
        {
          $byte  = 2;
        }
        $tmp .= substr($text, $i, $byte);
        $i += $byte;
        if  (strlen($tmp) >= $linelength)
        {
          $ret[] = $tmp;
          $tmp   = '';
        }
      }
      if  (strlen($tmp))
      {
        $ret[] = $tmp;
      }
      return($ret);
    }
/*
**     void close()
**     close PDF object
*/
    function close()
    {
      if ($this->pdf)
      {
        $this->pdf->Close();
        unset($this->pdf);
      }
    }
/*
**     void quit()
**
*/
    function quit()
    {
      if (is_file($this->pdfFileName))
      {
        unlink($this->pdfFileName);
      }
    }
  }
?>
