<?php
  #
  # Program id     : ImapClient.inc.php
  #
  # subject        : WebMail---Imap Client
  #
  #
  /*
  ** save as "ImapClient.inc.php"
  */
  //
  //
  require_once('Mail/mimeDecode.php');
  require_once('Net/POP3.php');

  class ImapClient
  {
    var $pop3;
    var $parts;
    var $port;
    var $message;
    var $header;
    var $body;
    var $multipart_alternative;

/*
**     void ImapClient()
**     class constructor
*/

  function ImapClient()
  {
    $this->pop3                  =& new Net_POP3;
    $this->pop3->_timeout        = 15;
    $this->parts                 = array();
    $this->port                  = 110;
    $this->message               = '';
    $this->header                = '';
    $this->body                  = '';
    $this->multipart_alternative = false;
    return;
  }

  /***************************************
  ** Below is a basic function to parse
  ** the output of the class. It will 
  ** produce:
  ** $parts['text'] - Indexed array of plain text parts
  ***************************************/

  function parse_output(&$obj)
  {
    if  (!empty($obj->parts))
    {
      $ctype = strtolower($obj->ctype_primary . '/'. $obj->ctype_secondary);
      #echo "test $ctype<br>\n";
      if  ($ctype==='multipart/alternative')
      {
        $this->multipart_alternative = true;
      }
      for($i=0; $i<count($obj->parts); $i++)
      {
        $this->parse_output($obj->parts[$i]);
      }
    }
    else
    {
      if  (isset($obj->ctype_primary))
      {
        $ctype = $obj->ctype_primary.'/'.$obj->ctype_secondary;
      }
      else
      {
        $ctype = 'text/plain';
      }      	
      $filenameD= isset($obj->d_parameters['filename']) ? $obj->d_parameters['filename'] : $obj->ctype_parameters['name'];
      $filenameC= isset($obj->ctype_parameters['name']) ? $obj->ctype_parameters['name'] : $obj->d_parameters['filename'];
       $filename =  !empty($filenameD) ? $filenameD : $filenameC;
      $ctype = strtolower($ctype);
      if  ($obj->disposition == 'attachment')
      {
        $this->SaveAttachment($filename, $obj->body, $ctype);
      }
      else
      {
        if  (!empty($obj->headers['content-id']))
        {
          $this->SaveInlineAttachment($filename, $obj->body, $obj->headers['content-id']);
          #echo $obj->headers['content-id'] . "<BR>\n";
          #echo $filenameC . "<BR>\n";
        }
        else
        {
          switch($ctype)
          {
            case 'text/plain':
                 $this->parts['text'][] = $obj->body;
                 break;
            case 'text/html':
                 $this->parts['html'][] = $obj->body;
                 break;
            default:
                 break;
          }
        }
      }
    }
  }

/*
** decode string base64 --> 8 bits
*/

    function binary_8bit(&$str)
    {
      $tmp=imap_mime_header_decode($str);
      $ret='';
      foreach($tmp as $a)
      {
        $ret .=trim($a->text);
      }
      /******
      echo "<PRE>\n";
      print_r($tmp);
      echo "</PRE>\n";
      exit;
      ******/
      return($ret);
    }

/*
** SaveAttachment() Save Attachment
*/

    function SaveAttachment(&$filename, &$data, $ctype='', $IsAtt=TRUE)
    {
      global $GlobalConfig, $WebMail_Uid;
      $ret=false;
      if  (empty($filename))
      {
        return($ret);
      }
      if  (!file_exists($GlobalConfig->AttDir))
      {
        if  (!mkdir($GlobalConfig->AttDir, 0755))
        {
          return($ret);
        }
      }
      $fname = basename($this->binary_8bit($filename));
      $FileName=$GlobalConfig->AttDir . '/' . $fname;
      $fd=fopen ($FileName,"wb");
      if  ($fd)
      {
        fwrite($fd,$data);
        fclose($fd);
        if  ($IsAtt)
        {
          $this->parts['attachments'][]= $WebMail_Uid . '/' . $fname;
          if  (!empty($ctype))
          {
            $this->parts['attachments_type'][]= $ctype;
            $this->parts['attachments_size'][]= filesize($FileName);
          }  
        }
        $ret=true;
      }
      return($ret);
    }

/*
** SaveInlineAttachment() Save Attachment
*/

    function SaveInlineAttachment(&$filename, &$data, &$cid)
    {
      global $WebMail_Uid, $_SERVER;
      if  ($this->SaveAttachment($filename, $data, '', FALSE))
      {
        #$len = strlen($cid) - 2;
        #$search = '/cid:' . preg_quote(substr($cid, 1, $len). '/') .  '/' ;
        if  (preg_match("/([<]*)([^<>]+)([>]*)/", $cid, $matches))
        {
          $m = $matches[2];
        }
        else
        {
          $m = $cid;
        }
        #echo $cid . "--$m==" . 'test1--' . $matches[2];	
        $search   = '/cid:' . preg_quote($m, '/') .  '/' ;
        $HttpsON  = strtolower($_SERVER['HTTPS']) == 'on' ? 's' : '';
        $replace  = 'http' . $HttpsON . '://' . $_SERVER['SERVER_NAME'];
        $replace .= '/webmail/attach.file/' . $WebMail_Uid . '/' . basename($this->binary_8bit($filename));
        $text   = preg_replace($search,$replace,$this->parts['html'][0]);
        /******
        echo "<PRE>\n";
        echo $text . "--\n";
        echo 'search=' . $search . "--\n";
        echo 'replace=' . $replace . "--\n";
        echo "</PRE>\n";
        exit;
        ******/
        $this->parts['html'][0] = $text;
        return(true);
      }
      else
      {
        return(false);
      }
    }

/*
** dele() delete a message from the socket
*/

    function dele(&$indices)
    {
      $ret=0;
      $len=count($indices);
      for($i=0;$i<$len;$i++)
      {
        if  ($this->pop3->deleteMsg($indices[$i]))
        {
          $ret++;
        }
      }
      return($ret);
    }

  /*
  ** GetMboxDir() Get MailBox Directory (Localhost mbox)
  */

    function &GetMboxDir()
    {
      global $GlobalConfig;
      $filename = array();
      if  (!file_exists($GlobalConfig->MBoxDir))
      {
        if  (!mkdir($GlobalConfig->MBoxDir, 0755))
        {
          return($filename);
        }
      }
      $dir = opendir($GlobalConfig->MBoxDir);
      while($item = readdir($dir))
      {
        if  (preg_match("/(\.eml)$/", $item))
        {
          $filename[]= $item;
        }
      } 
      return($filename);
    }

  /*
  ** GetFromMbox() Get Mail From(Localhost mbox)
  */

    function GetFromMbox(&$filename, $detail)
    {
      global $GlobalConfig, $WebMail_Uid;
      $ret=false;
      if  (empty($filename))
      {
        return($ret);
      }
      if  (!file_exists($GlobalConfig->MBoxDir))
      {
        if  (!mkdir($GlobalConfig->MBoxDir, 0755))
        {
          return($ret);
        }
      }
      $FileName=$GlobalConfig->MBoxDir . '/' . $filename;
      $data = get_file($FileName);
      if  (!empty($data))
      {
        $message = MessageDecrypt($data, $WebMail_Uid);
        if  ($detail==TRUE)
        {
          $this->message = $message;
        }
        else
        {
          $this->SplitHeaderBody($message);
          $this->message = $this->header . CRLF .CRLF;
          unset($this->header);
          unset($this->body);
        }
        $ret=true;
      }
      else
      {
        $ret = FALSE;
      }
      return($ret);
    }

  /*
  ** SplitHeaderBody split message to header & body
  */

    function SplitHeaderBody(&$message)
    {
      if  (empty($message))
      {
        $ret = FALSE;
      }
      else
      {      	
        $pos = strpos($message, (CRLF . CRLF));
        if  ($pos === false) 
        {
          $ret = FALSE;
        }
        else
        {
          $this->header = substr($message, 0, $pos);
          $this->body   = substr($message, $pos+(2*strlen(CRLF)));
          $ret=true;
        }
      }
      return($ret);
    }
    
  /*
  ** Check Exceed Disk Quota ?
  */

    function ExceedQuota($mesglen)
    {
      global $GlobalConfig;	
      $ret = FALSE;	
      $filename =& $this->GetMboxDir();
      $UsedDiskSpace = 0;
      foreach($filename as $value)
      {
        $UsedDiskSpace += $this->retr_MessageSize(0, $value);
      }
      //
      // if $mesglen = -1 return total storage usages
      //
      if  ($mesglen == -1)
      {
      	$ret = $UsedDiskSpace;
      }
      else
      {
        $UsedDiskSpace += $mesglen;      	
        if  ($UsedDiskSpace >= $GlobalConfig->Quota['MaxQuota'])
        {
          $ret = TRUE;
        }
      }
      return($ret);
    }

  /*
  ** SaveToMbox() Save Mail to Disk(Localhost mbox)
  */

    function SaveToMbox(&$message_id, &$data, $ToMcrypt=FALSE)
    {
      global $GlobalConfig, $WebMail_Uid;
      $ret=false;
      if  (empty($message_id))
      {
        return($ret);
      }
      if  (!file_exists($GlobalConfig->MBoxDir))
      {
        if  (!mkdir($GlobalConfig->MBoxDir, 0755))
        {
          return($ret);
        }
      }
      if  ($ToMcrypt && $GlobalConfig->EncrptMessage[$WebMail_Uid])
      {
        $mcrpyt_key = $WebMail_Uid;
      }
      else
      {
        $mcrpyt_key = '';
      }
      $message = MboxEncrypt($data, $mcrpyt_key);

      //
      // check disk quota
      //
      if  ($this->ExceedQuota(strlen($message)))
      {
      	return($ret);
      }
      $FileName=$GlobalConfig->MBoxDir . '/' . $message_id;
      $fd=fopen ($FileName,"wb");
      if  ($fd)
      {
        fwrite($fd,$message);
        fclose($fd);
        $ret=true;
      }
      return($ret);
    }

  /*
  ** SaveMail() Move a message into localhost mbox
  */

    function SaveMail($seq)
    {
      global $DefaultConfig;
      $ret=false;
      $this->retr_message($seq, FALSE);
      $message_id = '';
      /******
      if  (!empty($this->parts['headers']['message-id']))
      {
        if  (preg_match("/([<]*)([^<>@]+)([@])([^<>@]+)([>]*)/i", $this->parts['headers']['message-id'], $regs))
        {
          $message_id  = $regs[2];
        }
        if  (empty($message_id))
        {
          $message_id  = $regs[0];
        }
      }
      if  (empty($this->parts['headers']['message-id']))
      {
        srand((double)microtime()*1000000);
        $message_id  = date("YmdHis") . "."  . md5(uniqid(rand()) . microtime());
      }
      srand((double)microtime()*1000000);
      $message_id  = date("YmdHis") . "."  . md5(uniqid(rand()) . microtime());
      ******/
      $message_id  = sprintf("%s_%d.eml", date("YmdHis"), $seq);
      /*********
      echo "<PRE>";
      echo $this->parts['headers']['message-id'] . "<BR>\n";
      echo $seq . "<BR>";
      echo $message_id . "<BR>";
      echo $regs[0] . "0<BR>";
      echo $regs[1] . "1<BR>";
      echo $regs[2] . "2<BR>";
      echo $regs[3] . "3<BR>";
      echo $regs[4] . "4<BR>";
      echo $regs[5] . "5<BR>";
      echo "</PRE>";
      exit;
      *********/
      if  (empty($DefaultConfig->SenderToCryptMBox))
      {
        $ToMcrypt = FALSE;
      }
      else
      {
        if  (strtoupper($DefaultConfig->SenderToCryptMBox) == 'ALL')
        {
          $ToMcrypt = TRUE;
        }
        else
        {
          if  (preg_match("/$DefaultConfig->SenderToCryptMBox/i", $this->parts['headers']['from'], $regs))
          {
            $ToMcrypt = TRUE;
          }
          else
          {
            $ToMcrypt = FALSE;
          }
        }
      }
      $ret = $this->SaveToMbox($message_id, $this->message, $ToMcrypt);
      return($ret);
    }
  /*
  ** SortMail() Sort message List
  */

    function &SortMail($sortby, $sortdir, $listtype='mbox')
    {
      $obj = new stdClass;	
      if  (strtolower($listtype) == 'mbox')
      {
        $filename =& $this->GetMboxDir();
      	foreach($filename as $value)
      	{
          $obj->filename[] = $value;
        }
        $nums = count($filename);
      }
      else
      {
        $nums = $this->stat();
      }
      if  ($nums < 1)
      {
        return($obj);	
      }
      for($i = 0; $i < $nums; $i++)
      {
        $obj->seq[] = $i + 1;
      }
      for($i = 0; $i < $nums; $i++)
      {
        if  (strtolower($listtype) == 'mbox')
        {
          $this->retr_message(0, FALSE, $obj->filename[$i], FALSE);
        }
        else
        {
          $this->retr_message(($i+1), FALSE, '', FALSE);
        }
        $obj->date[]    = $this->parts['headers']['date'];
        $obj->from[]    = $this->parts['headers']['from'];
        $obj->subject[] = $this->parts['headers']['subject'];
        $obj->size[]    = (int)$this->parts['headers']['content-length'];
      }
      $tmp_array = array();
      switch($sortby)
      {
        case SORTDATE:
             #$tmp_array = $obj->date;
             for($i = 0; $i < $nums; $i++)
             {
               $tmp_array[$i] = strtotime($obj->date[$i]);
             }
             break;
        case SORTFROM:
             $tmp_array = $obj->from;
             break;
        case SORTSUBJECT:
             $tmp_array = $obj->subject;
             break;
        case SORTSIZE:
             $tmp_array = $obj->size;
             break;
        case SORTSEQ:
             $tmp_array = $obj->seq;
             break;
        default:
             $tmp_array = $obj->seq;
             break;
      }          	
      switch($sortdir)
      {
        case 0:
             asort($tmp_array);
             break;
        default:
             arsort($tmp_array);
             break;
      }
      foreach($tmp_array as $key => $value)
      {
        $obj->mesgno[] = $key;
      }
      /**
      echo "<PRE>";
      print_r($obj);
      echo "</PRE>";
      exit;
      **/
      return($obj);
    }
    
/*
 * retr_detail() reads a message from the socket
 */

    function retr_detail($seq, $detail)
    {
      $message = '';
      if  ($detail==TRUE)
      {
        $ret = $this->pop3->getMsg($seq);
      }
      else
      {
        $ret = $this->pop3->getRawHeaders($seq) . CRLF . CRLF;
      }
      if  ($ret)
      {
        $message = $ret;      	
        $ret     = TRUE;
      }
      $this->message = $message;
      return($ret);
    }



    /*
    ** retr_message() reads a message body from the socket
    */

    function retr_message($seq, $ToDecode=TRUE, $filename='', $detail=TRUE)
    {
      $ret = false;
      unset($this->parts);
      $this->parts = array();
      if  (empty($filename))
      {                      	
        $ret = $this->retr_detail($seq, $detail);
      }
      else
      {
        $ret = $this->GetFromMbox($filename, $detail);
      }
      if  ($ret)
      { 
        $out = new Mail_mimeDecode($this->message, "\r\n");
        $params  = array(
                         'include_bodies' => TRUE,
	                 'decode_headers' => TRUE,
		         'decode_bodies'  => TRUE
                        );
        $output = $out->decode($params);
        /****
        echo "<PRE>";
        echo $message;
        print_r($output);
        echo "</PRE>";
        exit;
        ****/
        foreach($output->headers as $key => $value)
        {
          $this->parts['headers'][$key] = $value;
        }                      	
        $this->parts['headers']['content-length'] = $this->retr_MessageSize($seq, $filename);
        if  (empty($this->parts['headers']['date']))
        {
          $tmp = explode(";", $output->headers['received'][count($output->headers['received']) - 1]);
          $this->parts['headers']['date'] = trim($tmp[count($tmp) - 1]);
        }
        if  (is_array($this->parts['headers']['date']))
        {
          $tmpDate = $this->parts['headers']['date'][0];
          unset($this->parts['headers']['date']);
          $this->parts['headers']['date'] = $tmpDate;
        }	
        if  (is_array($this->parts['headers']['subject']))
        {
          $tmpDate = $this->parts['headers']['subject'][0];
          unset($this->parts['headers']['subject']);
          $this->parts['headers']['subject'] = $tmpDate;
        }	
        if  ($ToDecode)
        {
          $this->parse_output($output);
        }
      }
      /**
      echo "<PRE>";
      echo $message;
      print_r($this->parts['headers']);
      echo "</PRE>";
      exit;
      **/
       return($ret);
    }

  /*
  ** retr_MessageSize() reads a message headers from the socket
  */

    function retr_MessageSize($seq, $filename='')
    {
      global $GlobalConfig;
      if  (empty($filename))
      {
        $tmp=$this->pop3->getListing($seq);
        return($tmp['size']);
      }
      else
      {
        $FName = $GlobalConfig->MBoxDir . '/' . $filename;
        return(filesize($FName));
      }
    }
    
  /*
  ** getSize() 
  ** @return mixed Either size of maildrop or false on error
  **/

    function getSize()
    {
      return($this->pop3->getSize());
    }

  /*
  ** stat() check numbers of mail in an Imap server
  **/

    function stat()
    {
      return($this->pop3->numMsg());
    }

   /*
  ** Logout() Logout from to an Imap server
  */

    function Logout()
    {
      return($this->pop3->disconnect());
    }


  /*
  ** Login() connects & login to an Imap server
  */

    function Login($hostname,$username,$password)
    {
      $ret = $this->pop3->connect($hostname, $this->port);
      if  ($ret===true)
      {
        $ret = $this->pop3->login($username, $password);
      }
      return $ret;
    }
  }
?>
