<?
  # Program id   : Kpd2CodeTable.inc.php
  #
  # subject      : ABCqHƯB޲zTt--NX table Codelist
  #
  #
  class Kpd2CodeTable
  {
    var $MaxItem;
    var $kind;
    var $no;
    var $name;
    var $_error;
    var $Db;
    //
    // constructor
    //
    function Kpd2CodeTable(&$db)
    {
      $this->MaxItem     = 0;
      $this->kind        = array();
      $this->no          = array();
      $this->name        = array();
      $this->_error      = '';
      $this->Db          = $db;
      $this->Db->autocommit(FALSE);
      $this->Db->setFetchMode(DB_FETCHMODE_ASSOC);
    }
    //
    // SELECT
    //
    function SelectKpd2CodeTable($kind, $no='')
    {
      $kind              = strtoupper(trim($kind));
      $no                = strtoupper(trim($no));
      $this->MaxItem     = 0;
      $this->kind        = array();
      $this->no          = array();
      $this->name        = array();
      $query  = "SELECT * FROM codelist WHERE kind = '$kind' ";
      if  (!empty($no))
      {
        $query .= "AND no = '$no' ";
      }
      else
      {
        $query .= " ORDER BY kind, no";
      }
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->kind[$i]  = $data->kind;
        $this->no[$i]    = $data->no;
        $this->name[$i]  = $data->name;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // SELECT Index By Code
    //
    function SelectKpd2CodeTableIndexByCode($kind)
    {
      $kind              = strtoupper(trim($kind));
      $this->MaxItem     = 0;
      $this->name        = array();
      $query  = "SELECT * FROM codelist WHERE kind = '$kind' ";
      $query .= " ORDER BY kind, no";
      # echo "$query<br>\n";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->name[$data->no]  = $data->name;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // SELECT By Partial name
    //
    function SelectCodeTableByName($kind, $name='')
    {
      $this->MaxItem   = 0;
      $this->kind      = array();
      $this->no        = array();
      $this->name      = array();
      $kind            = strtoupper(trim($kind));
      $name            = AddSlashes(trim($name));
      $query  = "SELECT * FROM codelist WHERE kind = '$kind' ";
      if  (!empty($name))
      {
        $query .= " AND  name LIKE '%$name%'";
      }
      $query .= " ORDER BY kind, no";
      $rst = $this->Db->Query($query);
      if  (DB::isError($rst))
      {
        $this->_error = $rst->GetMessage();
        return(0);
      }

      // echo "$query<br>\n";
      /*****
      echo "<PRE>\n";
      print_r($rst);
      echo "</PRE>\n";
      exit;
      *****/
      $this->MaxItem=$rst->numRows();
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $data=(object)$rst->fetchRow();
        $this->kind[$i]  = $data->kind;
        $this->no[$i]    = $data->no;
        $this->name[$i]  = $data->name;
      }
      $rst->free();
      return($this->MaxItem);
    }
    //
    // INSERT
    //
    function InsertKpd2CodeTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $kind   = strtoupper(trim($this->kind[$i]));
        $no     = strtoupper(trim($this->no[$i]));
        $name   = addslashes(trim($this->name[$i]));
        $query  = "INSERT INTO codelist (";
        $query .= "kind, no, name)";
        $query .= " values ";
        $query .= "(";
        $query .= "'$kind', ";
        $query .= "'$no',   ";
        $query .= "'$name'  ";
        $query .= ")";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          #/***
          echo "$query<br>\n";
          echo "<PRE>\n";
          print_r($rst);
          echo "</PRE>\n";
          #***/
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // UPDATE
    //
    function UpdateKpd2CodeTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $kind   = strtoupper(trim($this->kind[$i]));
        $no     = strtoupper(trim($this->no[$i]));
        $name   = addslashes(trim($this->name[$i]));
        $query  = "UPDATE codelist SET ";
        $query .= "name = '$name' ";
        $query .= "WHERE ";
        $query .= "kind = '$kind' AND ";
        $query .= "no   = '$no' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return($this->MaxItem);
    }
    //
    // DELETE
    //
    function DeleteKpd2CodeTable()
    {
      for($i=0;$i<$this->MaxItem;$i++)
      {
        $kind   = strtoupper(trim($this->kind[$i]));
        $no     = strtoupper(trim($this->no[$i]));
        $query  = "DELETE FROM codelist ";
        $query .= "WHERE ";
        $query .= "kind = '$kind' AND no = '$no' ";
        # echo "$query<br>\n";
        $rst = $this->Db->Query($query);
        if  (DB::isError($rst))
        {
          $this->_error = $rst->GetMessage();
          $this->Db->rollback();
          return(0);
        }
        $cmdTuples=$this->Db->affectedRows();
        if  ($cmdTuples==0)
        {
          $this->Db->rollback();
          return($cmdTuples);
        }
      }
      $this->Db->commit();
      return(true);
    }
  }
?>