<?
  #
  # Program id     : PDFGenerator.inc.php
  #
  # subject        : PDF documents Reportor
  #
  #

/*
** save as "PDFGenerator.inc.php"
*/

  class PDFGenerator
  {
    var $pageWidth     = a4_width;
    var $pageHeight    = a4_height;
    var $CreateNewPage = FALSE;
    var $Debug         = FALSE;
    var $pdfDir        = '';
    var $pdf;
    var $pdfFileName;
    var $pdfFileURL;
    var $FileExpireTime = 60;
    var $template;
    var $cfonts;
    var $efonts;
    var $cfont;
    var $efont;
    var $ErrMsg;
/*
**     void PDFGenerator()
**     class constructor
*/

    function PDFGenerator($templateFileName, $Debug=FALSE, $pdfDir='/pdf/pdf_files')
    {
      global $_SERVER;
      $this->Debug = $Debug;
      if  (!empty($pdfDir))
      {
      	$this->pdfDir = $_SERVER['DOCUMENT_ROOT'] . $pdfDir;
      }
      if  (!file_exists($this->pdfDir))
      {
        mkdir($this->pdfDir, 0777);
      }
      $tempFileName = tempnam('' , 'PDF_');
      unlink($tempFileName);
      $this->pdfFileName = $this->pdfDir . '/' . basename($tempFileName) . '.pdf';
      $this->pdfFileURL  = $pdfDir . '/' . basename($tempFileName) . '.pdf';
      if  ($this->Debug)
      {
        echo 'test1 ' . $this->pdfFileName . "<BR>\n";
        echo 'test2 ' . $this->pdfFileURL  . "<BR>\n";
      }
      $this->pdf = PDF_new();
      #PDF_set_parameter($this->pdf, "license", "X43400-4321CD-2678EF-AD4988");
      if (!PDF_open_file($this->pdf, $this->pdfFileName))
      {
        $this->ErrMsg = $this->pdfFileName . ' file open fail !!!';
        return;
      }
      if  (is_file($templateFileName))
      {
        $this->PrepareTemplate($templateFileName);
      }
      PDF_set_info($this->pdf, "Author", "Uwe Steinmann");
      PDF_set_info($this->pdf, "Title", "Test for PHP wrapper of PDFlib 2.0");
      PDF_set_info($this->pdf, "Creator", "See Author");
      PDF_set_info($this->pdf, "Subject", "Testing");
    }
/*
**     void PrepareTemplate()
**     Prepare page template
*/

    function PrepareTemplate($templateFileName)
    {
      $data = implode('', file($templateFileName));
      $p = xml_parser_create('ISO-8859-1');
      xml_parser_set_option($p,XML_OPTION_CASE_FOLDING,0);
      xml_parser_set_option($p,XML_OPTION_SKIP_WHITE, 0);
      xml_parse_into_struct($p, $data, &$vals, &$index);
      xml_parser_free($p);
      if  ($this->Debug)
      {
        echo "<PRE>";
        print_r($vals);
        echo "</PRE>";
      }
      foreach($vals as $key=>$val)
      {
        if  ($val[type] != 'complete')
        {
          continue;
        }
        if  ($this->Debug)
        {
          echo 'tag ->' . $val[tag] . "<br>\n";
          if  ($val[attributes])
          {
            foreach($val[attributes] as $key2=>$val2)
            {
              echo $key2 . '->' . $val2 . "<br>\n";
            }
          }
        }
        switch($val[tag])
        {
          case 'page':
               $this->pageWidth  = $val[attributes][w];
               $this->pageHeight = $val[attributes][h];
               $this->template = PDF_begin_template($this->pdf,
                                                    $this->pageWidth,
                                                    $this->pageHeight
                                                   );
               break;
          case 'set':
               PDF_set_parameter($this->pdf,
                                 $val[attributes][name],
                                 $val[attributes][value]
                                );
               break;
          case 'template':
               $pdi = PDF_open_pdi($this->pdf, $val[attributes][name], '', 0);
               if  ($pdi)
               {
                 $pdi_pg = PDF_open_pdi_page($pdi, $val[attributes][page]);
                 PDF_place_pdi_page($this->pdf, $pdi_pg, 0, 0, 0, 0);
                 PDF_close_pdi_page($this->pdf, $pdi_pg);
                 PDF_close_pid($this->pdf, $pdi);
               }
               break;
          case 'cfont':
               $this->cfonts[name]  = $val[attributes][name];
               $this->cfonts[cmaps] = $val[attributes][cmaps];
               $this->cfont = PDF_findfont ($this->pdf,
                                            $this->cfonts[name],
                                            $this->cfonts[cmaps],
                                            0
                                           );
               break;
          case 'efont':
               $this->efonts[name]  = $val[attributes][name];
               $this->efonts[cmaps] = $val[attributes][cmaps];
               $this->efont = PDF_findfont ($this->pdf,
                                            $this->efonts[name],
                                            $this->efonts[cmaps],
                                            0
                                           );
               break;
          case 'line':
               $sx  = $val[attributes][sx];
               $sy  = $val[attributes][sy];
               $ex  = $val[attributes][ex];
               $ey  = $val[attributes][ey];
               $lw  = (float)$val[attributes][linewidth];
               if  ($lw==(float)(0.0))
               {
                 $lw = (float)(0.001);
               }
               if  ($val[attributes][repeat])
               {
                 $repeat = $val[attributes][repeat];
               }
               else
               {
                 $repeat = 1;
               }
               $incx  = (int)($val[attributes][incx]);
               $incy  = (int)($val[attributes][incy]);
               if  ($this->Debug)
               {
                 echo "$sx $sy $ex $ey $incx $incy $repeat<BR>\n";
               }
               if  ($lw)
               {
                 PDF_setlinewidth($this->pdf, $lw);
               }
               for($i=0; $i < $repeat; $i++)
               {
                 PDF_moveto($this->pdf, $sx + ($i * $incx), $sy + ($i * $incy));
                 PDF_lineto($this->pdf, $ex + ($i * $incx), $ey + ($i * $incy));
               }
               PDF_stroke($this->pdf);
               break;
          case 'rect':
               $sx  = $val[attributes][sx];
               $sy  = $val[attributes][sy];
               $w   = $val[attributes][width];
               $h   = $val[attributes][height];
               $lw  = (float)$val[attributes][linewidth];
               if  ($lw==(float)(0.0))
               {
                 $lw = (float)(0.001);
               }
               if  ($this->Debug)
               {
                 echo "$sx $sy $w $h $lw<BR>\n";
               }
               if  ($lw)
               {
                 PDF_setlinewidth($this->pdf, $lw);
               }
               PDF_rect($this->pdf, $sx, $sy, $w, $h);
               PDF_stroke($this->pdf);
               break;
          case 'text':
               $this->ShowText($val[attributes][value],
                               $val[attributes][x],
                               $val[attributes][y],
                               $val[attributes][size],
                               $val[attributes][type]
                              );

               break;
        }
      }
      if  ($this->template)
      {
        PDF_end_template($this->pdf);
      }
    }
/*
**     void NewPage()
**     create NewPage
*/
  function NewPage($page=0)
  {
    if  (!$this->pdf)
    {
      return(0);
    }
    PDF_begin_page($this->pdf, $this->pageWidth, $this->pageHeight);
    if  ($this->template)
    {
      PDF_place_image($this->pdf, $this->template, (float)0.0, (float)0.0, (float)1.0 );
    }
    PDF_create_bookmark($this->pdf, "Page $page", "");
    //PDF_add_bookmark($this->pdf, "Page $page");
    $this->CreateNewPage = TRUE;
  }
/*
**     void EndPage()
**
*/
  function EndPage()
  {
    if  ($this->CreateNewPage===TRUE)
    {
      PDF_end_page($this->pdf);
    }
  }
/*
**     void OutputDoc()
**
*/
  function OutputDoc()
  {
    if (is_file($this->pdfFileName))
    {
      $len = filesize($this->pdfFileName);
      #header("Cache-Control: no-store, no-cache, must-revalidate");
      header("Content-Type: application/x-phpdownloadd");
      header("Content-Disposition: attachment; filename=" . basename($this->pdfFileName));
      header("Content-Description: PHP4 Generated Data" );
      readfile($this->pdfFileName);
    }
    // also have a look through the directory, and remove the files
    // that are older than
    if  ($d = @opendir($this->pdfDir))
    {
      while(($file= readdir($d)) != FALSE)
      {
        if  (substr($file, 0, 4) == 'PDF_')
        {
          // then check to see if this one is too old
          $ftime = filemtime($this->pdfDir . '/' . $file);
          if  (time() - $ftime > $this->FileExpireTime)
          {
            unlink($this->pdfDir . '/' . $file);
          }
        }
      }
    }
  }
/*
**     void OutputDoc_1()
**
*/
  function OutputDoc_1($Redirect=False)
  {
?>

    <HTML>
    <HEAD>
      <TITLE>PDF Generator OUTPUT</TITLE>
      <SCRIPT LANGUAGE="JavaScript">
        <!--
        function go_now()
        {
          window.open("<?=$this->pdfFileURL?>", "PDF");
          // window.location.href="<?=$this->pdfFileURL?>"
        }
        // -->
      </SCRIPT>
    </HEAD>
<?
  if  ($Redirect)
  {
    echo("<BODY OnLoad=\"go_now()\">\n");
  }
  else
  {
    echo("<BODY>\n");
  }
?>
      <A href="<?=$this->pdfFileURL?>">o</A> pSX{e
    </BODY>
    </HTML>
<?
    /*****
    if (is_file($this->pdfFileName))
    {
      $len = filesize($this->pdfFileName);
      #header("Cache-Control: no-store, no-cache, must-revalidate");
      header("Content-Type: application/pdf");
      header("Content-Disposition: attachment; filename=foo.pdf");
      header("Content-Description: PHP4 Generated Data" );
      readfile($this->pdfFileName);
    }
    *****/
    // also have a look through the directory, and remove the files
    // that are older than
    if  ($d = @opendir($this->pdfDir))
    {
      while(($file= readdir($d)) != FALSE)
      {
        if  (substr($file, 0, 4) == 'PDF_')
        {
          // then check to see if this one is too old
          $ftime = filemtime($this->pdfDir . '/' . $file);
          if  (time() - $ftime > $this->FileExpireTime)
          {
            unlink($this->pdfDir . '/' . $file);
          }
        }
      }
    }
  }
  //
  // Write Text
  //
    function ShowText($text, $posx=0, $posy=0, $fontsize=10, $fontfamily='cfont')
    {
      if ($this->pdf)
      {
        if    ($fontfamily == 'cfont')
        {
          $font =& $this->cfont;
        }
        else
        {
          $font =& $this->efont;
        }
        PDF_setfont($this->pdf,
                    $font,
                    $fontsize
                   );
        PDF_show_xy($this->pdf, $text, $posx, $posy);
        // PDF_fit_textline($this->pdf, $text, $posx, $posy, "");
      }
    }
    //
    // Write Blocked Text()
    //
    function ShowTextBlocked($text, $posx=0, $posy=0, $fontsize=10, $linelength=10, $fontfamily='cfont')
    {
      $lencnt = 0;
      if ($this->pdf)
      {
        if    ($fontfamily == 'cfont')
        {
          $font =& $this->cfont;
        }
        else
        {
          $font =& $this->efont;
        }
        PDF_setfont($this->pdf,
                    $font,
                    $fontsize
                   );
        if  (!is_array($text))
        {
          $text = $this->TextWrapLines($text, $linelength);
        }
      	$lencnt = count($text);
      	for($i = 0 ; $i < $lencnt; $i++)
      	{
          if  ($i==0)
          {
            PDF_show_xy($this->pdf, $text[$i], $posx, $posy);
          }
          else
          {
            PDF_continue_text($this->pdf, $text[$i]);
          }
        }
      }
      return($lencnt);
    }
  //
  // Text Wrap to array (lines)
  //
    function &TextWrapLines($text, $linelength=10)
    {
      $ret   = array();
      $tmp   = '';

      $len   = strlen($text);
      for($i = 0 ; $i < $len;)
      {
        $char_ord = ord(substr($text, $i, 1));
        $byte  = 1;
        if  ($char_ord >= 0x80)
        {
          $byte  = 2;
        }
        $tmp .= substr($text, $i, $byte);
        $i += $byte;
        if  (strlen($tmp) >= $linelength)
        {
          $ret[] = $tmp;
          $tmp   = '';
        }
      }
      if  (strlen($tmp))
      {
        $ret[] = $tmp;
      }
      return($ret);
    }
/*
**     void close()
**     close PDF object
*/
    function close()
    {
      if ($this->pdf)
      {
        if  ($this->template)
        {
          PDF_close_image($this->pdf, $this->template);
        }
        PDF_close($this->pdf);
      }
    }
/*
**     void delete()
**     delete PDF object
*/
    function delete()
    {
      if ($this->pdf)
      {
        PDF_delete($this->pdf);
      }
    }
/*
**     void quit()
**
*/
    function quit()
    {
      if (is_file($this->pdfFileName))
      {
        unlink($this->pdfFileName);
      }
    }
  }
?>
